#ifndef __THE_MAZE_OF_GALIOUS_2_ACTIVE_APPLICATION
#define __THE_MAZE_OF_GALIOUS_2_ACTIVE_APPLICATION


class ActiveMOG2Application {
	friend class ActionSCRIPT;
	friend class ValueSCRIPT;
	friend class ActiveMOG2;

	friend class GameWindow;
	friend class GameDebugWindow;

	friend void myMusicPlayer(void *udata, Uint8 *stream, int len);
	friend void init_music(class ActiveMOG2Application *game);


public:
	ActiveMOG2Application(MOG2 *game);
	~ActiveMOG2Application();

	int get_variable_value(char *vname,int *ival,char **sval,ActiveOBJECT **oval);
	void set_variable_value(char *vname,int value);
	void set_variable_value(char *vname,char *value);
	void set_variable_value(char *vname,ActiveOBJECT *value);

	void Execute(void);
	void sound(class VIEWPORT *vp,int sfx_atenuation_min,int sfx_atenuation_max);	/* Plays the sounds of the current state of the game */ 

	long int random(int min,int max);

	int get_current_cycle(void);

	bool find_object(ActiveOBJECT *o);

private:
	bool event(SDL_Event *event);

	List<VARIABLE> application_variables;

	int n_states,state;
	ActionSCRIPT **s_action;
	ActiveOBJECT *application_foreign;

	ActiveMOG2 *active_game;
	bool terminated;

	int screen_x,screen_y;
	int fps,hw_render;
	int player_plane;
	int sfx_atenuation_min,sfx_atenuation_max;

	int game_mode;
	FILE *replay_fp;
	class KEYBOARDSTATE **keyboardstate;
	int n_LVKs;
	int event_time,event_key,event_val;

	List<char> tmp_strings;

	int current_cycle;

	// Random Number Generator:
	class TRanrotBGenerator *random_generator;

	// Sound:
	List<class PLAYSAMPLE> play_samples;
	int music_priority;
	char *music_playing;
	int music_volume,sfx_volume;
	List<char> music_parts;
	char *music_sequence;
	int music_sequence_ip;
	int music_part;


};


#endif
