#ifndef MOG2_ACTION_SCRIPTS
#define MOG2_ACTION_SCRIPTS

#define ACTION_CMD_DELETE		-1
#define ACTION_CMD_NONE			0
#define ACTION_CMD_SEQ			1
#define ACTION_CMD_PARALLEL		2
#define ACTION_CMD_IF			3
#define ACTION_CMD_WHILE		4
#define ACTION_CMD_WHILE_ELSE	30
#define ACTION_CMD_DO			5
#define ACTION_CMD_PAUSE		6
#define ACTION_CMD_ATOMIC		7
#define ACTION_CMD_TERMINATE	10
#define ACTION_CMD_TERMINATECHILD	11
#define ACTION_CMD_GETCHILD		8
#define ACTION_CMD_STATE		12
#define ACTION_CMD_SET			13
#define ACTION_CMD_MOVE			20
#define ACTION_CMD_CREATEOBJECT	21
#define ACTION_CMD_CREATECHILD	22
#define ACTION_CMD_CREATEGLUEDCHILD	23

#define ACTION_CMD_DM_MODE_FACTOR	24
#define ACTION_CMD_DM_BLINK		29
#define ACTION_CMD_DM_COLOR1	25
#define ACTION_CMD_DM_COLOR2	26

#define ACTION_CMD_SET_INVINCIBLE	27
#define ACTION_CMD_LEAVELADDER	28

#define ACTION_CMD_NEWVARIABLE	32
#define ACTION_CMD_KILLVARIABLE	33

#define ACTION_CMD_PLAY_SAMPLE	34
#define ACTION_CMD_PLAY_SAMPLE_PAN	35

#define ACTION_CMD_PLAY_MUSIC	9
#define ACTION_CMD_STOP_MUSIC	14

#define ACTION_CMD_ADD_FOCUSING	15

#define ACTION_CMD_DRAWPIXEL	16
#define ACTION_CMD_DRAWLINE		17
#define ACTION_CMD_DRAWBOX		18

#define ACTION_CMD_CHANGEMAP	19

#define ACTION_CMD_DELETE_VIEWPORT	31
#define ACTION_CMD_SUB_FOCUSING		36

#define ACTION_CMD_RESETGAME		37
#define ACTION_CMD_STOPGAME			38
#define ACTION_CMD_RESUMEGAME		39

#define ACTION_CMD_GETPLAYER		41
#define ACTION_CMD_SETPLAYERNAME	40

#define ACTION_CMD_SETPLAYERKEYBOARD	42
#define ACTION_CMD_GAMEMODE				43

#define ACTION_CMD_DRAWBITMAP	44

#define ACTION_CMD_GETPARENT	45
#define ACTION_CMD_GETROOT		46
#define ACTION_CMD_CLEAR_FOCUSING		47

#define ACTION_CMD_CASE			48
#define ACTION_CMD_RANDOM_CASE	49

#define ACTION_CMD_MENU_ADDOPTION	50
#define ACTION_CMD_MENU_CLEAROPTIONS	51
#define ACTION_CMD_MENU_SUBSTOPTION	52


#define ACTION_MAX_CMD	53


#define MAX_ACTION_PARAMETERS	9


class ActionSCRIPT {
	friend class GameDebugWindow;
	friend class BScriptDebugWnd;

	friend class BViewActionScriptWnd;

public:
	ActionSCRIPT(void);
	ActionSCRIPT(ActionSCRIPT &s);
	~ActionSCRIPT(void);

	bool save(FILE *fp);
	bool load(FILE *fp,class MOG2 *game);

	char *generate_string(void);

	void init(void);
	bool cycle(class ActiveOBJECT *o,class ActiveROOM *r,ActiveMAP *map,ActiveMOG2 *game,class ActiveINTERFACE *interf,class ActiveMOG2Application *app,ActiveOBJECT **foreign_object,int location,class KEYBOARDSTATE **LVK,int n_LVKs);

	void copy_state(ActionSCRIPT *s);
	void simplify(void);

	bool uses_sample(class SAMPLE *s);

private:

	int timmer;

	int command;
	class ValueSCRIPT *vpar[MAX_ACTION_PARAMETERS];
	class ConditionSCRIPT *cond;
	bool cond_result,first_cycle,while_else;
	List<ActionSCRIPT> aparlist;
	List<ValueSCRIPT> vparlist;	/* This list is only used by CASE and RANDOM_CASE */ 
	List<bool> finished;	/* just used by the PARALLEL command */ 

	int dx,dy; /* Size of the printed SCRIPT, for the edit windows.	*/ 
};


#endif

